// Raided from GNU Go code, vanilla.c

#include "gnugo.h"

void quit() {
}

gnugostream::gnugostream() {
  length = 0;
  verbose = 1;
  if (pipe(pfd_a) == -1)
    error("can't open pipe a");
  if (pipe(pfd_b) == -1)
    error("can't open pipe b");
  switch (fork()) {
  case -1:
    error("fork failed (try chopsticks)");
  case 0:
    /* Attach pipe a to stdin */
    if (dup2(pfd_a[0], 0) == -1) 
      error("dup pfd_a[0] failed");
    /* attach pipe b to stdout" */
    if (dup2(pfd_b[1], 1) == -1)
      error("dup pfd_b[1] failed");
    execlp("gnugo", "gnugo", "--mode", "gtp", "--quiet", NULL);
    error("execlp failed");
  }
  /* We use stderr to communicate with the client since stdout is needed. */
  /* Attach pipe a to to_gnugo_stream  */
  to_gnugo_stream = fdopen(pfd_a[1], "w");
  /* Attach pipe b to from_gnugo_stream */
  from_gnugo_stream = fdopen(pfd_b[0], "r");
}

char* gnugostream::sendcmd(const char* cmd)
{
    string returnness = "";
    sprintf(client_line,cmd);
    int length = 0;
    if ( !strncmp(client_line, "quit", 4)) {
      TELL_GNUGO("quit\n");
      return 0;
    }
    if (!strncmp(client_line, "genmove_black", 13)) {
      char *token;
      const char delimiters[] = " \t\r\n";
      float value1, value2;

      TELL_GNUGO("top_moves_black\n");
      ASK_GNUGO(gnugo_line);
      token = strtok(gnugo_line, delimiters);
      token = strtok(NULL, delimiters);
      printf(token);
      TELL_GNUGO("black ");
      TELL_GNUGO(token);
      TELL_GNUGO("\n");
      ASK_GNUGO(gnugo_line);
      while (length != 1) {
	ASK_GNUGO(gnugo_line);
        returnness += gnugo_line;
	length = strlen(gnugo_line);
	printf(gnugo_line);
	fflush(stdout);
      }
    }
    else {
      TELL_GNUGO(client_line);
      while (length != 1) {
	ASK_GNUGO(gnugo_line);
        returnness += gnugo_line;
	length = strlen(gnugo_line);
	printf(gnugo_line);
	fflush(stdout);
      }
    }
    char* rn = (char*)returnness.c_str();
    return rn;
}



int gnugostream::loop()
{

    int length = 0;
    if (!fgets(client_line, 128, stdin) 
	|| !strncmp(client_line, "quit", 4)) {
      TELL_GNUGO("quit\n");
      return 1;
    }
    if (!strncmp(client_line, "genmove_black", 13)) {
      char *token;
      const char delimiters[] = " \t\r\n";
      float value1, value2;

      TELL_GNUGO("top_moves_black\n");
      ASK_GNUGO(gnugo_line);
      token = strtok(gnugo_line, delimiters);
      token = strtok(NULL, delimiters);
      printf(token);
      TELL_GNUGO("black ");
      TELL_GNUGO(token);
      TELL_GNUGO("\n");
      ASK_GNUGO(gnugo_line);
      while (length != 1) {
	ASK_GNUGO(gnugo_line);
	length = strlen(gnugo_line);
	printf(gnugo_line);
	fflush(stdout);
      }
    }
    else {
      TELL_GNUGO(client_line);
      while (length != 1) {
	ASK_GNUGO(gnugo_line);
	length = strlen(gnugo_line);
	printf(gnugo_line);
	fflush(stdout);
      }
    }
    return 0;
}

void
error(const char *msg)      
{
  fprintf(stderr, "gnugostream: %s\n", msg);
}

/*
 * Local Variables:
 * tab-width: 8
 * c-basic-offset: 2
 * End:
 */
